"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;

  return {
    visitor: {
      CallExpression: function CallExpression(path) {
        if (path.node.callee.name === fnName) {
          if (path.node.arguments.length === 1) {
            var arg = path.node.arguments[0];

            if (arg.type === "Identifier") {
              path.node.type = "StringLiteral";
              path.node.value = arg.name;
            } else if (arg.type === "MemberExpression") {
              path.node.type = "StringLiteral";
              path.node.value = arg.property.name;
            } else {
              throw new Error("Expected type 'Identifier|MemberExpression', but got '" + arg.type + "'. " + example);
            }
          } else {
            throw new Error("Invalid signature. " + fnName + " expects a single argument. " + example);
          }
        }

        return undefined;
      }
    }
  };
};

var fnName = "nameof";
var example = "Example: " + fnName + "(myVar.myProp); // returns \"myProp\"";